# Only Fedora & RHEL 5+ can use selinux
%if 0%{?rhel} && "%rhel" < "5"
%define without_selinux 1
%endif

%define selinux_variants mls strict targeted

Name:           mailgraph
Epoch:		1
Version:        1.15
Release:        2%{?dist}
Summary:        A RRDtool frontend for Mail statistics
Packager :      Django <django@mailserver.guru>
Distribution:   CentOS 7
Group:          System Environment/Daemons
License:        GPL+

URL:            http://dokuwiki.nausch.org/doku.php/centos:mail_c7:mta_13
Source0:        http://repository.nausch.org/public/var/mailgraph-1.15.tar.gz
Source1:        mailgraph.service
Source2:        mailgraph.conf.el7
Source3:        mailgraph.sysconfig
Source4:        mailgraph.te
Source5:        mailgraph.fc
Source6:        mailgraph.if
Source7:        mailgraph.init
Source8:        mailgraph.conf.el6
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if ! 0%{?without_selinux}
BuildRequires:  checkpolicy, selinux-policy-devel, hardlink
%endif

Requires:       perl(File::Tail), rrdtool, httpd, queuegraph
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
%else
Requires:       initscripts chkconfig
%endif

BuildArch:      noarch

%description
Mailgraph is a very simple mail statistics RRDtool frontend for Postfix and
Sendmail that produces daily, weekly, monthly and yearly graphs of
received/sent and bounced/rejected mail.

%if ! 0%{?without_selinux}
%package selinux
Summary:        A RRDtool frontend for Mail statistics

Group:          System Environment/Daemons
%define selinux_policyver %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp) 
%if "%{selinux_policyver}" != ""
Requires:       selinux-policy >= %{selinux_policyver}
%endif
Requires:       %{name} = %{version}-%{release}

#Requires(post):   /usr/sbin/semodule, /sbin/restorecon, /sbin/fixfiles, %{name}
#Requires(postun): /usr/sbin/semodule, /sbin/restorecon, /sbin/fixfiles, %{name}

%description selinux
This is the selinux policy for mailgraph.
%endif


%prep
%setup -q

%if ! 0%{?without_selinux}
mkdir selinux
cp -p %{SOURCE4} %{SOURCE5} %{SOURCE6} ./selinux/
%endif

%build
cd selinux
for selinuxvariant in %{selinux_variants}; do
  make NAME=${selinuxvariant} -f %{_datadir}/selinux/devel/Makefile
  mv %{name}.pp %{name}.pp.${selinuxvariant}
  make NAME=${selinuxvariant} -f %{_datadir}/selinux/devel/Makefile clean
done
cd -

%install
rm -rf $RPM_BUILD_ROOT
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_sbindir}
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_unitdir}
%else
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_initrddir}
%endif
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_datadir}/mailgraph
%{__install} -d -m 0755 $RPM_BUILD_ROOT/%{_localstatedir}/lib/mailgraph
%{__install} -d -m 0775 $RPM_BUILD_ROOT/%{_localstatedir}/cache/mailgraph

%{__install} -p -m 0755 mailgraph.cgi $RPM_BUILD_ROOT/%{_datadir}/mailgraph
%{__install} -p -m 0644 mailgraph.css $RPM_BUILD_ROOT/%{_datadir}/mailgraph
%{__install} -p -m 0644 rrdtool-3dlogo.png $RPM_BUILD_ROOT/%{_datadir}/mailgraph
%{__install} -p -m 0755 mailgraph $RPM_BUILD_ROOT/%{_sbindir}/mailgraph
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
%{__install} -p -m 0755 %SOURCE1 $RPM_BUILD_ROOT/%{_unitdir}/mailgraph.service
%else
%{__install} -p -m 0755 %SOURCE7 $RPM_BUILD_ROOT/%{_initrddir}/mailgraph
%endif
%if 0%{?rhel} >= 7
%{__install} -p -m 0644 %SOURCE2 $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/mailgraph.conf
%else
%{__install} -p -m 0644 %SOURCE8 $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/mailgraph.conf
%endif
%{__install} -p -m 0644 %SOURCE3 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/mailgraph

%if ! 0%{?without_selinux}
cd selinux
for selinuxvariant in %{selinux_variants}; do
  install -d $RPM_BUILD_ROOT/%{_datadir}/selinux/${selinuxvariant}
  install -p -m 644 %{name}.pp.${selinuxvariant} \
    $RPM_BUILD_ROOT/%{_datadir}/selinux/${selinuxvariant}/%{name}.pp
done
cd -

# Hardlink identical policy module packages together
/usr/sbin/hardlink -cv $RPM_BUILD_ROOT/%{_datadir}/selinux
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
%else
    /sbin/chkconfig --add %{name} 2>&1 > /dev/null || :
%endif
fi

%if 0%{?fedora} < 15 || 0%{?rhel} < 7
if [ "$1" -ge "1" ]; then
  /sbin/service %{name} condrestart 2>&1 > /dev/null || :
fi
%endif

%preun
#exit 0
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
    /bin/systemctl --no-reload disable mailgraph.service > /dev/null 2>&1 || :
    /bin/systemctl stop mailgraph.service > /dev/null 2>&1 || :
%else
    /sbin/service %{name} stop 2>&1 > /dev/null || :
    /sbin/chkconfig --del %{name} 2>&1 > /dev/null || :
%endif
fi

%postun
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
%endif
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
    /bin/systemctl try-restart mailgraph.service >/dev/null 2>&1 || :
%else
    /sbin/service %{name} condrestart 2>&1 > /dev/null || :
%endif
fi

%if ! 0%{?without_selinux}
%post selinux
/sbin/service %{name} status &> /dev/null ||:
STATUS=$?

if [ $STATUS -eq 0 ]; then
  /sbin/service %{name} stop &> /dev/null ||:
fi

for selinuxvariant in %{selinux_variants}; do
  /usr/sbin/semodule -s ${selinuxvariant} -i \
    %{_datadir}/selinux/${selinuxvariant}/%{name}.pp &> /dev/null || :
done

if [ $STATUS -eq 0 ]; then
  /sbin/service %{name} start &> /dev/null ||:
fi

# Fix up non-standard file contexts
/sbin/fixfiles -R %{name} restore || :
/sbin/restorecon -R %{_localstatedir}/cache/%{name} || :
/sbin/restorecon -R %{_localstatedir}/lib/%{name} || :

%postun selinux
# Clean up after package removal
if [ $1 -eq 0 ]; then
  /sbin/service %{name} status &> /dev/null ||:
  STATUS=$?

  if [ $STATUS -eq 0 ]; then
    /sbin/service %{name} stop &> /dev/null ||:
  fi

  # Remove SELinux policy modules
  for selinuxvariant in %{selinux_variants}
  do
    /usr/sbin/semodule -s ${selinuxvariant} -r %{name} &> /dev/null || :
  done

  if [ $STATUS -eq 0 ]; then
    /sbin/service %{name} start &> /dev/null ||:
  fi

  /sbin/fixfiles -R %{name} restore || :

  # Clean up any remaining file contexts
  [ -d %{_localstatedir}/cache/%{name} ] && \
    /sbin/restorecon -R %{_localstatedir}/cache/%{name} &> /dev/null || :
  [ -d %{_localstatedir}/lib/%{name} ] && \
    /sbin/restorecon -R %{_localstatedir}/lib/%{name} &> /dev/null || :
fi
%endif

%triggerun -- mailgraph < 1.14-12
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply mailgraph
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save mailgraph >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del mailgraph >/dev/null 2>&1 || :
/bin/systemctl try-restart mailgraph.service >/dev/null 2>&1 || :


%files
%defattr(-,root,root,-)
%dir %{_localstatedir}/lib/mailgraph
%dir %attr(0775,root,apache) %{_localstatedir}/cache/mailgraph
%{_sbindir}/*
%{_datadir}/mailgraph
%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
%{_unitdir}/mailgraph.service
%else
%{_initrddir}/mailgraph
%endif
%config(noreplace) %{_sysconfdir}/sysconfig/mailgraph
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mailgraph.conf
%doc CHANGES COPYING README

%if ! 0%{?without_selinux}
%files selinux
%defattr(-,root,root,-)
%{_datadir}/selinux/*/%{name}.pp
%doc selinux/*
%endif

%changelog
* Tue Feb 3 2015 Django <django@mailserver.guru> - 1.15.2-1
- Rebuild
  postscreen blocked connections are now counted as rejected mails

* Tue Feb 3 2015 Django <django@mailserver.guru> - 1.15-1
- Build as mailgraph-ng a fork of David Schweikert's popular mailgraph
  Special thanks goes to:
   ° David Schweikert for Mailgraph
   ° Ralf Hildebrandt for Queuegraph
   ° Markus Neubauer for Greygraph
   ° Sebastian van de Meer for his both Mailgraph-patches 

* Fri Jan 30 2015 Django <django@mailserver.guru> - 1.14-1
- Initial build for CentOS 7
